﻿using System.Collections.Generic;
//
namespace PerceptiveMCAPI.Types
{
   public class campaignCreateParms
   {
      public string apikey { get; set; }
      public EnumValues.campaign_type type { get; set; }
      public campaignCreateOptions options { get; set; }
      public Dictionary<string, string> content { get; set; }
      public campaignSegmentOptions segment_opts { get; set; }
      public Dictionary<string, string> type_opts { get; set; }
      // -------------------------------------
      public campaignCreateParms()
      {
         this.apikey = MCAPISettings.default_apikey;
         this.type = MCAPISettings.default_campaign_type;
         this.options = new campaignCreateOptions();
         this.content = new Dictionary<string, string>();
         this.segment_opts = new campaignSegmentOptions();
         this.type_opts = new Dictionary<string, string>();
      }
      public campaignCreateParms(
       EnumValues.campaign_type type,
       campaignCreateOptions options,
       Dictionary<string, string> content,
       campaignSegmentOptions segment_opts,
       Dictionary<string, string> type_opts )
      {
         this.apikey = MCAPISettings.default_apikey;
         this.type = type;
         this.options = options;
         this.content = content;
         this.segment_opts = segment_opts;
         this.type_opts = type_opts;
      }
      public campaignCreateParms( string apikey,
         EnumValues.campaign_type type,
         campaignCreateOptions options,
         Dictionary<string, string> content,
         campaignSegmentOptions segment_opts,
         Dictionary<string, string> type_opts )
      {
         this.apikey = apikey;
         this.type = type;
         this.options = options;
         this.content = content;
         this.segment_opts = segment_opts;
         this.type_opts = type_opts;
      }

   }
}
