﻿using System;
using System.Collections.Generic;
using System.Web.Script.Serialization;
using System.Xml.Linq;
//
using PerceptiveMCAPI.Types.Internal;
//
namespace PerceptiveMCAPI.Types
{
	public class campaignBounceMessageOutput : Api_BaseOutput
	{
		public campaignBounceMessageResults result { get; set; }
		public campaignBounceMessageParms inputParms { get; private set; }
		//
		public campaignBounceMessageOutput( campaignBounceMessageInput input )
			: base( input )
		{
			inputParms = input.parms;
			result = new campaignBounceMessageResults();
		}
		// --------------------------------------------------- tostring
		public override string ToString()
		{
			return "ToString not available";
		}

		#region ================================================================== format setup

		// ---- serial
		internal void Format( string api_Request, string api_Response )
		{
			this.api_Request = api_Request;
			this.api_Response = api_Response;
			// ----------------------------------
			if ( this.api_OutputType == EnumValues.OutputType.JSON )
				outputJSON();
			else if ( this.api_OutputType == EnumValues.OutputType.XML )
				outputXML();
		}

		// ---- xmlrpc
		internal void Format( x_campaignBounceMessage rpcResult )
		{
			this.api_Request = EnumValues.NotSupplied;
			this.api_Response = EnumValues.NotSupplied;
			// ------------------------
			this.result = FormatResults( rpcResult );
		}

		#endregion

		#region ================================================================= Output

		// ---------------------------------------------------------- outputXML
		private void outputXML()
		{
			XElement xml = XElement.Parse( this.api_Response );
			// error check
			Api_Error error = apiSerial.GetXmlOutputError( xml );
			if ( error != null )
			{
				this.api_ErrorMessages.Add( error );
				return;
			}
			// -------------------------------------------- get values
			DateTime dt;
			try
			{
				DateTime.TryParse( xml.Element( "date" ).Value, out dt );
				result.date = dt;
				result.email = xml.Element( "email" ).Value ?? "";
				result.message = xml.Element( "message" ).Value ?? "";
			}
			catch ( Exception ex )
			{
				this.api_ErrorMessages.Add( apiException.FormatError( ex ) );
			}
		}
		// ---------------------------------------------------------- outputJSON
		private void outputJSON()
		{
			JavaScriptSerializer jss = new JavaScriptSerializer();
			try
			{
				if ( this.api_Response.Contains( EnumValues.JSONErrorString ) )
				{
					Api_Error err = jss.Deserialize<Api_Error>( this.api_Response );
					this.api_ErrorMessages.Add( err );
				}
				else
				{
					x_campaignBounceMessage jsonResult = jss.Deserialize<x_campaignBounceMessage>( this.api_Response );
					this.result = FormatResults( jsonResult );
				}
			}
			catch ( Exception ex )
			{
				this.api_ErrorMessages.Add( apiException.FormatError( ex ) );
			}
		}

		// ----------------------------------------------------------------------- FormatResults
		private campaignBounceMessageResults FormatResults( x_campaignBounceMessage x_results )
		{
			var results = new campaignBounceMessageResults();
			DateTime dt;
			//
			DateTime.TryParse( x_results.date, out dt );
			results.date = dt;
			results.email = x_results.email;
			results.message = x_results.message;
			//
			return results;
		}

		#endregion
	}
}
