﻿using System.Collections.Generic;
using PerceptiveMCAPI.Types;
//
namespace PerceptiveMCAPI
{
   internal static partial class ValidateInput
   {
      // campaignGeoOpensForCountry
      internal static List<Api_ValidatorMessage> Validate( campaignGeoOpensForCountryInput input )
      {
         List<Api_ValidatorMessage> messages = ValidateBaseParameters( input as Api_BaseInput );
         Api_ValidatorMessage val;
         //-----------------------
         // apikey
         val = Validator.apikey_valid( input.parms.apikey );
         if ( val != null ) messages.Add( val );
         // campaign id
         val = Validator.cid_valid( input.parms.cid );
         if ( val != null ) messages.Add( val );
         // code (country)
         // TODO: validate country code
         messages.Add( Validator.FormatMsg(
            EnumValues.MessageLevel.Information, "code", "Country code is not being validated" ) );
         //--------------------
         return messages;
      }
   }
}
