﻿using System.Collections.Generic;
using PerceptiveMCAPI.Types;
//
namespace PerceptiveMCAPI
{
	internal static partial class ValidateInput
	{
		// campaignMembers
		internal static List<Api_ValidatorMessage> Validate( campaignMembersInput input )
		{
			List<Api_ValidatorMessage> messages = ValidateBaseParameters( input as Api_BaseInput );
			Api_ValidatorMessage val;
			//-----------------------
			// apikey
			val = Validator.apikey_valid( input.parms.apikey );
			if ( val != null ) messages.Add( val );
			// campaign id
			val = Validator.cid_valid( input.parms.cid );
			if ( val != null ) messages.Add( val );
			//
			// status -- not specific defaults to ALL
			//
			// start 
			val = Validator.start_valid( input.parms.start );
			if ( val != null ) messages.Add( val );
			// limit 
			val = Validator.limit_valid( input.parms.limit, MCAPISettings.max_campaignMembers );
			if ( val != null ) messages.Add( val );
			//--------------------
			return messages;
		}
	}
}
