﻿using System.Collections.Generic;
using PerceptiveMCAPI.Types;
//
namespace PerceptiveMCAPI
{
	internal static partial class ValidateInput
	{
		// listMemberInfo
		internal static List<Api_ValidatorMessage> Validate( listMemberInfoInput input )
		{
			List<Api_ValidatorMessage> messages = ValidateBaseParameters( input as Api_BaseInput );
			Api_ValidatorMessage val;
			//-----------------------
			// apikey
			val = Validator.apikey_valid( input.parms.apikey );
			if ( val != null ) messages.Add( val );
			// id
			val = Validator.ListId_valid( input.parms.id );
			if ( val != null ) messages.Add( val );
			// email
			val = Validator.collection_has_entries( input.parms.email_address, "email_address" );
			if ( val != null ) messages.Add( val );
			else
			{
				foreach ( var email in input.parms.email_address )
				{
					val = Validator.email_valid( email );
					if ( val != null ) messages.Add( val );
				}
			}
			//--------------------
			return messages;
		}
	}
}
