﻿using System.Collections.Generic;
using PerceptiveMCAPI.Types;
//
namespace PerceptiveMCAPI
{
   internal static partial class ValidateInput
   {
      // listUpdateMember
      internal static List<Api_ValidatorMessage> Validate ( listUpdateMemberInput input )
      {
         List<Api_ValidatorMessage> messages = ValidateBaseParameters( input as Api_BaseInput );
         Api_ValidatorMessage val;
         //-----------------------
         // apikey
         val = Validator.apikey_valid( input.parms.apikey );
         if ( val != null ) messages.Add( val );
         // id
         val = Validator.ListId_valid( input.parms.id );
         if ( val != null ) messages.Add( val );
         // email_address
         val = Validator.email_valid( input.parms.email_address );
         if ( val != null ) messages.Add( val );
         // merge_vars
         val = Validator.merge_vars_valid( input.parms.merge_vars );
         if ( val != null ) messages.Add( val );
         //---------------
         // email_type
         // --------------
         // email type validation is ignored as a 'not specified' value is valid 
         // in order to retain what ever type the subscriber already has
         //--------------------
         return messages;
      }
   }
}
